package com.wawrzek.fumbo.coordinator;

import jade.content.lang.Codec.*;
import jade.content.onto.*;
import jade.content.onto.basic.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;

import org.apache.log4j.*;

import com.wawrzek.fumbo.*;
import com.wawrzek.fumbo.core.*;

/**
 * @author Wawrzek
 * 
 * Behaviuor that collects answer form workers. Then the answer is matched with original Task 
 * and is sent to who has asked
 * 
 */
public class AnswerCollectLoop extends CyclicBehaviour
{
    /* (non-Javadoc)
     * @see jade.core.behaviours.Behaviour#action()
     */
    public void action()
    {
        //waiting for INFORM messages
        MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
        ACLMessage msg = myAgent.receive(mt);

        if (msg != null)
        {
            Action a = null;
            try
            {
                a = (Action) myAgent.getContentManager().extractContent(msg);
                Task task = (Task) a.getAction();
                Logger.getLogger(Consts.COORDINATOR_LOG).info("received an answer to task no. " + task.getId());
                Logger.getLogger(Consts.COORDINATOR_LOG).debug("final resultSet: " + task.getResultSet());
                ((Coordinator) myAgent).getGui().getLogTextPane().refresh();
                myAgent.addBehaviour(new SendAnswerBackBehaviour(task));
            }
            catch (UngroundedException e)
            {
                Logger.getLogger(Consts.COORDINATOR_LOG).error("Ungrounded error while collecting answer: " + e.getMessage());
                e.printStackTrace();
            }
            catch (CodecException e)
            {
                Logger.getLogger(Consts.COORDINATOR_LOG).error("codec error while collecting answer: " + e.getMessage());
                e.printStackTrace();
            }
            catch (OntologyException e)
            {
                Logger.getLogger(Consts.COORDINATOR_LOG).error("ontology error while collecting answer: " + e.getMessage());
                e.printStackTrace();
            }
        }
        else
        {
            block();
        }
    }
}