package com.wawrzek.fumbo.coordinator;

import jade.core.*;
import jade.core.behaviours.*;

import org.apache.log4j.*;

import com.wawrzek.fumbo.*;
import com.wawrzek.fumbo.tools.*;

/**
 * Behaviour to watch over existing worker agents - adding new and killing old ones.
 * 
 * @author Wawrzek
 *
 */
public class LookForWorkersLoop extends TickerBehaviour
{

    /**
     * @param agent
     * @param time
     */
    public LookForWorkersLoop(Agent agent, long time)
    {
        super(agent, time);
    }

   
    /* (non-Javadoc)
     * @see jade.core.behaviours.TickerBehaviour#onTick()
     */
    protected void onTick()
    {
        try
        {
            ((Coordinator) myAgent).getAgentsManager().killAbsentWorkers();
            ((Coordinator) myAgent).getAgentsManager().makeNewAgents();
        }
        catch (AgentException e)
        {
            Logger.getLogger(Consts.COORDINATOR_LOG).error("Error managing Workers: "+e.getMessage());
            e.printStackTrace();
        }
    }
}