package com.wawrzek.fumbo.coordinator;

import com.wawrzek.fumbo.gui.*;

import jade.core.*;
import jade.core.behaviours.*;

/**
 * @author wawrzek
 *
 * Behaviour that reads system log and puts into GUI text pane.
 */
public class RefreshLogLoop extends TickerBehaviour
{
    /** text pane where log will bu put */
    LogTextPane pane;
    
    /**
     * @param agent agent that behaves
     * @param pane text pane where log will be put
     * @param time how often log will be read (in milliseconds
     */
    public RefreshLogLoop(Agent agent, LogTextPane pane, long time)
    {
        super(agent, time);
        this.pane = pane;
    }
    
    /* (non-Javadoc)
     * @see jade.core.behaviours.TickerBehaviour#onTick()
     */
    protected void onTick()
    {
        pane.refresh();
    }
}
