package com.wawrzek.fumbo.coordinator;

import jade.content.lang.Codec.*;
import jade.content.onto.*;
import jade.content.onto.basic.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;

import org.apache.log4j.*;

import com.wawrzek.fumbo.*;
import com.wawrzek.fumbo.core.*;

/**
 * @author wawrzek
 *
 * Behavior that sends Fumbo Anser (Maximal Result Set) to agent that asked for it.
 * Answer content is build upon ExternalOntology.
 * 
 */
public class SendAnswerBackBehaviour extends OneShotBehaviour
{
    /** task to which answer is built */
    private Task task;
    
    /**
     * 
     * @param task task to which answer is built  
     */
    public SendAnswerBackBehaviour(Task task) {
        this.task= task;
    }
    
    
    /* (non-Javadoc)
     * @see jade.core.behaviours.Behaviour#action()
     */
    public void action()
    {
        TaskManager taskManager =((Coordinator)myAgent).getTaskManager();
        ACLMessage answer = taskManager.createReplyMessage(task.getId());
        ExternalTask externalTask = new ExternalTask(task.getRdqlQuestion(), task.getResultSet(), task.getResultsCount());
        Action a = new Action(myAgent.getAID(), externalTask);
        try
        {
            myAgent.getContentManager().fillContent(answer, a);
        }
        catch (CodecException e1)
        {
           e1.printStackTrace();
        }
        catch (OntologyException e1)
        {
            e1.printStackTrace();
        }
        
        myAgent.send(answer);
        
        Logger.getLogger(Consts.COORDINATOR_LOG).info("coordinator sent answer to task no. "+task.getId()+" back to the user");
        taskManager.cleanAfterTask(task.getId());
    }

}
