package com.wawrzek.fumbo.coordinator;

import jade.content.*;
import jade.core.*;

/**
 * @author wawrzek
 * 
 * Container for information about Worker Agent.  
 */
public class WorkerInfo implements Concept
{
    /** name of rule file that worker runs upon */
    private String fileName;
    /** AID of worker */
    private AID aid;
    /** name of worker agent */
    private String name;

    /**
     * 
     * @param fileName name of rule file
     * @param name name of agent created
     */
    public WorkerInfo(String fileName, String name)
    {
        this.fileName = fileName;
        this.aid = new AID(name, AID.ISGUID);
        this.name = name;
    }

    /**
     * needed by ontology
     *
     */
    public WorkerInfo()
    {

    }

    public String getFileName()
    {
        return fileName;
    }

    public AID getAid()
    {
        return aid;
    }

    public void setAid(AID aid)
    {
        this.aid = aid;
    }

    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }
}