package com.wawrzek.fumbo.coordinator;

import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;

import com.wawrzek.fumbo.*;

/**
 * Behaviour to listen to workers errors. Worker asks coordinator to kill him.
 * 
 * @author Wawrzek
 *  
 */
public class WorkersFailureLoop extends CyclicBehaviour
{
    /* (non-Javadoc)
     * @see jade.core.behaviours.Behaviour#action()
     */
    public void action()
    {
        MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.FAILURE);
        mt = MessageTemplate.and(mt, MessageTemplate.MatchContent("killme"));

        ACLMessage msg = myAgent.receive(mt);
        if (msg != null)
        {
            AID aid = msg.getSender();
            Coordinator coordinator = (Coordinator) myAgent;
            coordinator.getAgentsManager().killWorker(aid);
        }
        else
        {
            block();
        }
    }
}