package com.wawrzek.fumbo.core;

import jade.content.onto.*;
import jade.content.schema.*;

import org.apache.log4j.*;

import com.wawrzek.fumbo.*;

/**
 * Ontology used to communicate with external world (outside Fumbo)
 * @author Wawrzek
 *
 */
public class ExternalOntology extends Ontology
{

    public static final String ONTOLOGY_NAME = "EXTERNAL-ontology";
    private static Ontology theInstance = new ExternalOntology();

    private static final String TASK = "ExternalTask";
    private static final String TASK_RDQL_QUESTION = "question";
    private static final String TASK_RESULTSET = "resultSet";
    private static final String TASK_RESULTCOUNT = "resultCount";

    public static Ontology getInstance()
    {
        return theInstance;
    }

    private ExternalOntology()
    {
        super(ONTOLOGY_NAME, BasicOntology.getInstance());

        try
        {
            add(new AgentActionSchema(TASK), ExternalTask.class);
            AgentActionSchema aas = (AgentActionSchema) getSchema(TASK);
            aas.add(TASK_RDQL_QUESTION, (PrimitiveSchema) getSchema(BasicOntology.STRING));
            aas.add(TASK_RESULTSET, (PrimitiveSchema) getSchema(BasicOntology.STRING));
            aas.add(TASK_RESULTCOUNT, (PrimitiveSchema) getSchema(BasicOntology.INTEGER));
        }
        catch (OntologyException e)
        {
            Logger.getLogger(Consts.COORDINATOR_LOG).fatal("error while creating external ontology");
            e.printStackTrace();
        }
    }
}