package com.wawrzek.fumbo.core.rulepart;

import com.wawrzek.fumbo.tools.*;

/**
 * @author Wawrzek
 * 
 * Abstract class for Condition classes
 */
public abstract class Condition
{
    /**
     * Text source of condition
     */
    private String source;
    
    public Condition(String source)
    {
        this.source = source;
    }
    
    /**
     * Returns if condition is fulfilled
     * 
     * @param question RDQL question 
     * @param answer RDF answer
     * @return true if condition is fulfilled, false otherwise
     * @throws AgentException
     */
    public abstract boolean isTrue(String question, String answer, String baseUri) throws AgentException;
}