package com.wawrzek.fumbo.core.rulepart;

/**
 * Class providing new meaning (SYNONYME) of a literal.
 * 
 * @author Wawrzek
 *
 */
public class Meaning
{
    /** first (current) meaning */
    private String first;
    /** second (new) meaning - SYNONIME */
    private String second;

    
    public Meaning(String first, String second)
    {
        this.first = first;
        this.second = second;
    }

    /**
     * created new RDQL query by replacing old literal with sonynim  
     * @param string query to be changed
     * @return changed query
     */
    public String replace(String string)
    {
        return string.replaceAll(first, second);
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object o)
    {
        if (!(o instanceof Meaning))
            return false;
        Meaning another = (Meaning) o;
        return ((this.first.equals(another.first)) && (this.second.equals(another.second)));
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString()
    {
        return first + " means " + second;
    }
}