package com.wawrzek.fumbo.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import com.wawrzek.fumbo.*;

public class CoordinatorGui extends JFrame
{
    private LogTextPane logPane;
    Coordinator myAgent;

    public CoordinatorGui(Coordinator a)
    {
        super("Fumbo - " + a.getLocalName());
        this.myAgent = a;

        JTabbedPane tabbedPane = new JTabbedPane();

        JTable wt = new JTable(new WorkersTableModel(a.getAgentsManager()));
        wt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        wt.getColumnModel().getColumn(0).setHeaderValue("Agent's Name");
        wt.getColumnModel().getColumn(1).setHeaderValue("Rule file");

        JScrollPane scrollPane = new JScrollPane(wt);
        wt.setPreferredScrollableViewportSize(new Dimension(500, 400));

        logPane = new LogTextPane(a.getConfig().getString(Consts.FLD_LOGFILENAME), (a.getConfig().getInt(Consts.FLD_WATCHLOG) == 1));

        Container container = new Container();
        container.setLayout(new BorderLayout());
        container.add(scrollPane, BorderLayout.CENTER);

        Container buttons = new Container();
        buttons.setLayout(new GridLayout(2, 1));
        buttons.add(new JButton(new AgentUpAction(a, wt)));
        buttons.add(new JButton(new AgentDownAction(a, wt)));

        container.add(buttons, BorderLayout.EAST);

        tabbedPane.addTab("Agents list", container);
        tabbedPane.addTab("Log", logPane.getJScrollPane());
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(tabbedPane, BorderLayout.CENTER);

        //RecordEdit re = new RecordEdit(this, myAgent.getConfig());
        //Record r = re.run(RecordEdit.STATUS_MODIFY);
        //if (r != null)
        //  myAgent.setConfig(r);

        addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                myAgent.doDelete();
            }
        });

        setResizable(false);
    }

    public void show()
    {
        pack();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        int centerX = (int) screenSize.getWidth() / 2;
        int centerY = (int) screenSize.getHeight() / 2;
        setLocation(centerX - getWidth() / 2, centerY - getHeight() / 2);
        super.show();
    }

    public LogTextPane getLogTextPane()
    {
        return logPane;
    }

}