package com.wawrzek.fumbo.gui;

import java.awt.*;
import java.io.*;

import javax.swing.*;

public class LogTextPane
{
    private BufferedReader reader;
    private FileInputStream fos;
    private JScrollPane scrollPane;
    private JTextPane textPane;
    private int howManyLines = 0;
    private boolean refreshLog = true;
    private static final int lineHeight = 20;

    public LogTextPane(String logFileName, boolean refreshLog)
    {
        this.refreshLog = refreshLog;

        textPane = new JTextPane();
        JPanel panel = new JPanel();
        panel.setLayout(new BorderLayout());
        panel.add(textPane, BorderLayout.CENTER);

        textPane.setPreferredSize(new Dimension(5000, 40000));
        textPane.setEditable(false);

        scrollPane = new JScrollPane(panel);
        scrollPane.setPreferredSize(new Dimension(500, 400));
        try
        {
            reader = new BufferedReader(new FileReader(logFileName));
        }
        catch (FileNotFoundException e)
        {
            e.printStackTrace();
            reader = null;
        }
    }

    public void refresh()
    {
        if (!refreshLog)
            return;
        String wynik = "";
        if (reader == null)
            return;
        try
        {
            while (true)
            {
                String line = reader.readLine();
                if (line == null)
                    break;
                wynik += line;
                wynik += "\n";
                howManyLines++;
            }
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        String all = textPane.getText() + wynik;
        textPane.setText(all);
        textPane.setPreferredSize(new Dimension(1000, howManyLines * lineHeight));
        textPane.invalidate();
    }

    public JScrollPane getJScrollPane()
    {
        return scrollPane;
    }

    public JTextPane getJTextPane()
    {
        return textPane;
    }

}