package com.wawrzek.fumbo.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import com.wawrzek.fumbo.tester.*;

/**
 * @author Wawrzek
 *  
 */
public class TesterGui extends JFrame
{
    Tester myAgent;
    JTextPane textPane;
    JTextPane firstAnswerTextPane;
    JButton button;

    JLabel label;

    private static final String mrsText = "Maximal Result Set (MRS)";
    private static final String baText = "Base Result Set";

    private long resultCount = 0;
    private long startCount = 0;

    public TesterGui(Tester agent)
    {
        super("Fumbo Tester");
        this.myAgent = agent;

        label = new JLabel("Press \"Ask Fumbo\" button!");

        button = new JButton(new SendTestAction(myAgent, this));
        button.setText("Ask Fumbo");
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(button, BorderLayout.NORTH);

        Container container = new Container();
        container.setLayout(new BorderLayout());

        Container leftContainer = new Container();
        leftContainer.setLayout(new BorderLayout());

        firstAnswerTextPane = new JTextPane();
        firstAnswerTextPane.setPreferredSize(new Dimension(500, 400));
        JScrollPane scrollPane = new JScrollPane(firstAnswerTextPane);
        leftContainer.add(scrollPane, BorderLayout.SOUTH);

        Container rightContainer = new Container();
        rightContainer.setLayout(new BorderLayout());
        textPane = new JTextPane();
        textPane.setPreferredSize(new Dimension(500, 400));
        scrollPane = new JScrollPane(textPane);
        rightContainer.add(scrollPane, BorderLayout.SOUTH);

        container.add(leftContainer, BorderLayout.WEST);
        container.add(rightContainer, BorderLayout.EAST);

        getContentPane().add(container, BorderLayout.CENTER);
        getContentPane().add(label, BorderLayout.SOUTH);
        addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                myAgent.doDelete();
            }
        });

        setResizable(false);
    }

    public void show()
    {
        pack();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        int centerX = (int) screenSize.getWidth() / 2;
        int centerY = (int) screenSize.getHeight() / 2;
        setLocation(centerX - getWidth() / 2, centerY - getHeight() / 2);

        super.show();
    }

    public void setText(String text, long resultCount)
    {
        this.resultCount = resultCount;
        refreshLabel();
        textPane.setEditable(false);
        firstAnswerTextPane.setText(firstAnswerTextPane.getText());
        textPane.setText(text);
    }

    /**
     *  
     */
    public void switchOnWaitMode()
    {
        button.setEnabled(false);
        firstAnswerTextPane.setText("");
        textPane.setText("");
        this.startCount = 0;
        this.resultCount = 0;
        refreshLabel();
    }

    public void switchOnWorkMode()
    {
        button.setEnabled(true);
    }

    /**
     * @param answer
     */
    public void setFirstAnswer(String answer, long count)
    {
        firstAnswerTextPane.setText(answer);
        this.startCount = count;
        refreshLabel();
    }

    public void refreshLabel()
    {
        label.setText(baText + " -  " + startCount + " entries, " + mrsText + " - " + resultCount + " entries");
        firstAnswerTextPane.setPreferredSize(new Dimension(500, 400));
        textPane.setPreferredSize(new Dimension(500, 400));
    }

}