package com.wawrzek.fumbo.gui;


import jade.util.leap.*;

import javax.swing.table.*;

import com.wawrzek.fumbo.coordinator.*;
import com.wawrzek.fumbo.core.*;

/**
 * @author S.T.Garp
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WorkersTableModel extends AbstractTableModel
{
    private String[] columnNames = { "Name", "Rule Name" };
    private AgentsManager agentsManager;

    private int workerCount = 0;

    public WorkersTableModel(AgentsManager am)
    {
        super();
        this.agentsManager = am;
        am.setTableModel(this);
    }
    
    public Object getValueAt(int row, int col)
    {
        ArrayList list = (ArrayList)agentsManager.getList();
        if (row>=list.size())
            return null;
        WorkerInfo wi = (WorkerInfo)list.get(row);
        switch (col){
            case 0: return wi.getName();
            case 1: return wi.getFileName();
            default: return null;
        }
    }

    public int getColumnCount()
    {
        return columnNames.length;
    }

    public int getRowCount()
    {
        return agentsManager.getList().size();
    }
}