package com.wawrzek.fumbo.tester;

import jade.content.lang.Codec.*;
import jade.content.onto.*;
import jade.content.onto.basic.Action;
import jade.core.*;
import jade.lang.acl.*;

import java.awt.event.*;
import java.beans.*;

import javax.swing.*;

import com.wawrzek.fumbo.*;
import com.wawrzek.fumbo.core.*;
import com.wawrzek.fumbo.tools.basic.*;
import com.wawrzek.fumbo.tools.recordedit.*;

/**
 * @author Wawrzek
 *
 */
public class SendTestAction implements javax.swing.Action
{
    private Tester myAgent;
    private JFrame frame;
    
    public SendTestAction(Tester agent,  JFrame frame ) {
        myAgent = agent;
        this.frame = frame;
    }
    
    /* (non-Javadoc)
     * @see javax.swing.Action#isEnabled()
     */
    public boolean isEnabled()
    {
        return true;
    }

    /* (non-Javadoc)
     * @see javax.swing.Action#setEnabled(boolean)
     */
    public void setEnabled(boolean arg0)
    {
    }

    /* (non-Javadoc)
     * @see javax.swing.Action#addPropertyChangeListener(java.beans.PropertyChangeListener)
     */
    public void addPropertyChangeListener(PropertyChangeListener arg0)
    {
    }

    /* (non-Javadoc)
     * @see javax.swing.Action#removePropertyChangeListener(java.beans.PropertyChangeListener)
     */
    public void removePropertyChangeListener(PropertyChangeListener arg0)
    {
    }

    /* (non-Javadoc)
     * @see javax.swing.Action#getValue(java.lang.String)
     */
    public Object getValue(String arg0)
    {
        return null;
    }

    /* (non-Javadoc)
     * @see javax.swing.Action#putValue(java.lang.String, java.lang.Object)
     */
    public void putValue(String arg0, Object arg1)
    {
    }

    /* (non-Javadoc)
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent arg0)
    {
        Record test = myAgent.getLastQuestion();
        if (test == null) {
            test = new Record();
            test.put("question", "Question","");
            test.put("aid", "Coordinator's address (AID)", "");
        }
        
        RecordEdit re = new RecordEdit(frame, test, "Ask Fumbo");
        test = re.run(RecordEdit.STATUS_MODIFY);
        if (test == null) {
            return;
        }
        
        
        
        myAgent.setLastQuestion(test);
        myAgent.getGui().switchOnWaitMode();
        RdfEngine rdfEngine = new RdfEngine();
        rdfEngine.readDataFromURL(myAgent.getConfig().getString(Consts.FLD_DATAURL));
        rdfEngine.query(test.getString("question"));
        String firstAnswer = rdfEngine.getAnswer();
        long size = rdfEngine.getAnswerCount();
        myAgent.getGui().setFirstAnswer(rdfEngine.getAnswer(), size);
        
        
        ExternalTask externalTask = new ExternalTask(test.getString("question"), firstAnswer, size);
        ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
        AID aid = new AID(test.getString("aid"), false);
        msg.addReceiver(aid);
        msg.setLanguage(myAgent.getCodec().getName());
        msg.setOntology(myAgent.getOntology().getName());
        
        Action a = new Action(myAgent.getAID(), externalTask);
        try
        {
            myAgent.getContentManager().fillContent(msg, a);
        }
        catch (CodecException e1)
        {
           e1.printStackTrace();
        }
        catch (OntologyException e1)
        {
            e1.printStackTrace();
        }

        myAgent.send(msg);
    }

}
