package com.wawrzek.fumbo.tester;

import jade.content.lang.*;
import jade.content.lang.sl.*;
import jade.content.onto.*;
import jade.core.*;

import java.io.*;

import com.wawrzek.fumbo.core.*;
import com.wawrzek.fumbo.gui.*;
import com.wawrzek.fumbo.tools.basic.*;

/**
 * @author Wawrzek
 *  
 */
public class Tester extends Agent
{
    private TesterGui gui;
    private Codec codec = new SLCodec();
    private Ontology externalOntology = ExternalOntology.getInstance();
    private Record lastQuestion;
    private Record globalConfig;

    protected void setup()
    {
        globalConfig = new Record();
        if (globalConfig.read("cfg" + File.separator + "fumbo.cfg") == false) {
            System.out.println("Tester cannot load global config");
            doDelete();
        }
        
        lastQuestion = new Record();
        lastQuestion.put("aid", "Question", "coordinator@wawrzek:1099/JADE");
        lastQuestion.put("question", "Coordinator's address (AID)", "SELECT ?x WHERE (?x  <http://chefmoz.org/rdf/elements/1.0/Cuisine> \"Chinese\")");
        try
        {
            getContentManager().registerLanguage(codec);
            getContentManager().registerOntology(externalOntology);
            getContentManager().setValidationMode(true);

            addBehaviour(new TesterAnswerCollectLoop());

            gui = new TesterGui(this);
            gui.show();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * @return
     */
    public Codec getCodec()
    {
        return codec;
    }

    /**
     * @return
     */
    public Ontology getOntology()
    {
        return externalOntology;
    }

    public TesterGui getGui()
    {
        return gui;
    }

    public Record getLastQuestion()
    {
        return lastQuestion;
    }

    public void setLastQuestion(Record lastQuestion)
    {
        this.lastQuestion = lastQuestion;
    }
    
    public Record getConfig() {
        return globalConfig;
    }
}