package com.wawrzek.fumbo.tester;

import jade.content.lang.Codec.*;
import jade.content.onto.*;
import jade.content.onto.basic.Action;
import jade.core.behaviours.*;
import jade.lang.acl.*;

import javax.swing.*;

import org.apache.log4j.*;

import com.wawrzek.fumbo.*;
import com.wawrzek.fumbo.core.*;

/**
 * @author Wawrzek
 *  
 */
public class TesterAnswerCollectLoop extends CyclicBehaviour
{
    /*
     * (non-Javadoc)
     * 
     * @see jade.core.behaviours.Behaviour#action()
     */
    public void action()
    {
        ACLMessage msg = myAgent.receive();

        if (msg != null)
        {
            try
            {
                if (msg.getPerformative() == ACLMessage.FAILURE)
                {
                    JOptionPane.showMessageDialog(null, "Connecting to Coordinator failed. You might have typed wrong address.\nPlease, try again.", "Failure", JOptionPane.ERROR_MESSAGE);
                    ((Tester) myAgent).getGui().switchOnWorkMode();
                    return;
                }
                if (msg.getPerformative() == ACLMessage.REQUEST)
                {
                    Logger.getLogger(Consts.COORDINATOR_LOG).debug("" + msg.getPerformative());
                    Action a = (Action) myAgent.getContentManager().extractContent(msg);
                    ExternalTask etask = (ExternalTask) a.getAction();

                    ((Tester) myAgent).getGui().setText(etask.getResultSet(), etask.getResultCount());
                    ((Tester) myAgent).getGui().switchOnWorkMode();
                }
            }
            catch (CodecException e)
            {
                Logger.getLogger(Consts.COORDINATOR_LOG).error("codec error while collecting answer: " + e.getMessage());
                e.printStackTrace();
            }
            catch (OntologyException e)
            {
                Logger.getLogger(Consts.COORDINATOR_LOG).error("ontology error while collecting answer: " + e.getMessage());
                e.printStackTrace();
            }
        }
        else
        {
            block();
        }
    }
}