package com.wawrzek.fumbo.tests;

import java.io.*;

import junit.framework.*;

import com.wawrzek.fumbo.core.*;
import com.wawrzek.fumbo.tools.*;

/**
 * @author S.T.Garp
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ExpandResultsetTests extends TestCase
{
    private Task[] tasks;
    private Rule[] rules;
    private static final String EXAMPLEDATAURL = "file:data\\enzymes.rdf";
    private static final String EXAMPLEBASEURI = "AAA";
    private static final String TESTRULESDIR = "rules";

    public static void main(String[] args)
    {
        junit.swingui.TestRunner.run(ExpandResultsetTests.class);
    }

    protected void setUp() throws Exception
    {
        tasks = new Task[1];
        rules = new Rule[3];

        tasks[0] = new Task(null, 0, null);

        File dir = new File(TESTRULESDIR);
        File[] files = dir.listFiles();
        rules = new Rule[files.length];

        for (int i = 0; i < files.length; i++)
        {
            File file = files[i];
            rules[i] = new Rule(file.getAbsolutePath());
        }
    }

    public void testExpandResultSet() throws AgentException
    {
        boolean ok = true;

        for (int t = 0; t < tasks.length; t++)
            for (int r = 0; r < rules.length; r++)
            {
                Task task = tasks[t];
                Rule rule = rules[r];
                task.expandResultSet(rule, EXAMPLEDATAURL, EXAMPLEBASEURI);
                System.out.println("---------------------------");
                System.out.println("task = " + task);
                System.out.println("rule = " + rule);
                System.out.println("result = " + task.getResultSet());
            }
        assertTrue(ok);
    }
}