package com.wawrzek.fumbo.tools.recordedit;

import java.awt.*;

import javax.swing.*;

import com.wawrzek.fumbo.tools.basic.*;

/**
 * @author S.T.Garp
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class RecordEdit extends JDialog
{
    JTextField[] fields;
    Record record;
    
    public static final int STATUS_MODIFY = 0;
    public static final int STATUS_VIEW = 1;

    public RecordEdit(JFrame frame, Record record, String title)
    {
        super(frame, true);
        this.record = record;
        setTitle(title);
        
        fields = new JTextField[record.getFields().length];
        getContentPane().setLayout(new GridLayout(fields.length+1,2));
        
        for (int i = 0; i < fields.length; i++)
        {
            String fieldCode = record.getFields()[i];
            String fieldName = record.getName(fieldCode);
            JTextField textField = new JTextField(record.getString(fieldCode));
            textField.setMinimumSize(new Dimension(100, 20));
            textField.setMaximumSize(new Dimension(100, 20));
            fields[i] = textField;
          
            getContentPane().add(new JLabel(fieldName+":"));
            getContentPane().add(textField);
        }
        JButton okButton = new JButton(new RecordEditOKAction(this));
        JButton cancelButton = new JButton(new RecordEditCancelAction(this));
        Box buttonBox = new Box(BoxLayout.X_AXIS);
        buttonBox.add(okButton);
        buttonBox.add(cancelButton);
        getContentPane().add(new JLabel(""));
        getContentPane().add(buttonBox);
        setSize(400, 20*(fields.length+1)+50);
        setResizable(false);
        getRootPane().setDefaultButton(okButton);
    }
    
    public Record run(int status)
    {
        setVisible(true);
        return record;
    }
    
    void buildRecord()
    {
        for (int i=0; i<record.getFields().length;i++)
        {
            String fieldCode = record.getFields()[i];
            Object value = (Object)fields[i].getText();
            record.put(fieldCode, value);
        }
    }
}